import numpy as np
import matplotlib.pyplot as plt

def p1_disks(size, radius, dist):
    
    x_v = range(0, size)
    y_v = range(0, size)
    X, Y = np.meshgrid(x_v, y_v)
    
    cb = (size/2+dist, size/2);
    cg = (size/2 - dist*np.sin(np.pi/6), size/2 - dist*np.cos(np.pi/6));
    cr = (size/2 - dist*np.sin(np.pi/6), size/2 + dist*np.cos(np.pi/6));
    
    B = ((X-cb[1])**2 + (Y-cb[0])**2 <= radius**2).astype(int)*255
    R = ((X-cr[1])**2 + (Y-cr[0])**2 <= radius**2).astype(int)*255
    G = ((X-cg[1])**2 + (Y-cg[0])**2 <= radius**2).astype(int)*255
    
    return R, G, B


size = 255
radius = 70
dist = 45

R, G, B = p1_disks(size, radius, dist)
h, w = R.shape

#Créer l'objet vidéo avec VideoWriter
video = cv2.VideoWriter('video.avi', cv2.VideoWriter_fourcc('M','J','P','G'), 5, (w, h))

for n in range(0,100):
    
    q = np.mod(n,3)
    
    if (q == 0):   #C1=Rouge-C2=Vert-C3=Bleu
        img = np.stack((R,G,B), axis = 2).astype('uint8')
    elif (q == 1):
        img = np.stack((B,R,G), axis = 2).astype('uint8')
    else:
        img = np.stack((B,G,R), axis = 2).astype('uint8')
        
    #Ajout du frame dans la vidéo  
    video.write(img)
    
video.release()