import matplotlib.pyplot as plt
import numpy as np
import skimage

I = plt.imread('../img/campagne.jpg')

#Boost de la saturation (optionnel)
I_hsv = skimage.color.rgb2hsv(I)
I_hsv[:,:,1] = I_hsv[:,:,1]*2
I_hsv[I_hsv > 1] = 1 #Seuillage des valeurs limites
I = (skimage.color.hsv2rgb(I_hsv)*255).astype('uint8')

#Inversion Cb, Cr
I_ycbcr = skimage.color.rgb2ycbcr(I)
I_ycbcr[:,:,1:3] = 255-I_ycbcr[:,:,1:3] 
I_inv = skimage.color.ycbcr2rgb(I_ycbcr) #passage RGB

#Image "niveaux de gris"
#I_g = (I[:,:,0] + I[:,:,1] + I[:,:,2])/3 # FAIL !! Car overflow du fait de l'uint8
#I_g = np.mean(I, axis=2) #OK conversion automatique en float
I_gray = I_ycbcr[:,:,0] #Canal Y 

#Masque binaire du cercle noir
X, Y = np.meshgrid(range(0,I.shape[1]), range(0,I.shape[0]))
C = (X-I.shape[1]/2)**2 +  (Y-I.shape[0]/2)**2 < 40**2

I_gray[C] = 0
I_inv[C] = 0  #broadcast de C (hxw) sur la 3ème dimension de I_inv (hxwx3)

plt.figure(1)
plt.imshow(I_inv)
plt.pause(2)
plt.imshow(I_gray, cmap='gray')







