import numpy as np
import matplotlib.pyplot as plt
from scipy import signal

img = (plt.imread('../img/moon.png')).astype('float')/255
img = plt.imread('../img/cat.jpg').astype('float')/255

print(img.dtype)

plt.figure(1)
plt.imshow(img)

if img.ndim == 2:
    h, w = img.shape
    c = 1
else:
    h, w, c = img.shape

H = [[1,1,1],[1,-8,1],[1,1,1]] #Filtre isotrope de détecteur de contours
C = img.copy()
if (c==3):
    for i in range(c):
        C[:,:,i] = signal.convolve2d(img[:,:,i], H, 'same') #option 'same' pour avoir la taille de l'image 
else:
    C = signal.convolve2d(img, H, 'same') #option 'same' pour avoir la taille de l'image 

beta = 2
res = img - beta*C #réhaussement des contrastes

#Normalisation pour rester dans l'intervalle initial
#Méthode 1
res[res>255] = 255
res[res<0] = 0
#Méthode 2
np.clip(res, 0, 255)

print(2)
plt.figure(2) 
plt.imshow(C)
plt.title('Contrastes')

plt.figure(3) 
plt.subplot(121)
plt.imshow(img, cmap='gray') 
plt.title('Image initiale')
plt.subplot(122)
plt.imshow(res, cmap='gray')
plt.title('Image réhaussée I-{}dI'.format(beta))
plt.show()

































